package com.fjhx.xmhjc.controller.open;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.xmhjc.entity.about.vo.AboutUsHonorVo;
import com.fjhx.xmhjc.entity.product.dto.ProductInfoSelectDto;
import com.fjhx.xmhjc.entity.product.vo.ProductCategoryVo;
import com.fjhx.xmhjc.entity.product.vo.ProductInfoVo;
import com.fjhx.xmhjc.entity.product.vo.ProductSubCategoryVo;
import com.fjhx.xmhjc.service.product.ProductCategoryService;
import com.fjhx.xmhjc.service.product.ProductInfoService;
import com.fjhx.xmhjc.service.product.ProductSubCategoryService;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

@RestController
@RequestMapping("/open/product")
public class OpenProductController {
    @Resource
    private ProductCategoryService productCategoryService;
    @Resource
    private ProductSubCategoryService subCategoryService;
    @Resource
    private ProductInfoService productInfoService;

    @PostMapping("/categoryList")
    public List<ProductCategoryVo> categoryList() {
        List<ProductCategoryVo> list = productCategoryService.listByOpen();
        return list;
    }


    @PostMapping("/subCategoryList/{categoryId}")
    public List<ProductSubCategoryVo> subCategoryList(@PathVariable Long categoryId) {
        List<ProductSubCategoryVo> list = subCategoryService.listByOpen(categoryId);
        return list;
    }

    @PostMapping("/info/{categoryId}/{subCategoryId}")
    public Page<ProductInfoVo> productInfoList(@PathVariable Long categoryId, @PathVariable Long subCategoryId, @RequestBody ProductInfoSelectDto dto) {
        Page<ProductInfoVo> list = productInfoService.pageByOpen(categoryId, subCategoryId, dto);
        return list;
    }

    @PostMapping("/info/detail/{id}")
    public ProductInfoVo productInfoList(@PathVariable Long id) {
        ProductInfoVo detail = productInfoService.detail(id);
        return detail;
    }
}
